.DSEG 
Display:	.BYTE 	32
Position:	.BYTE	1
StrobePos:	.BYTE	1

.def	RamTemp		=r0

.def	Temp		=r16
.def	Temp2		=r17
.def	Setted		=r18
.def	DlyA		=r19
.def	DlyB		=r20
.def	FadeDlyA	=r21
.def	FadeDlyB	=r22
.def	LpCnt		=r23
.def	TimeSlot	=r24
.def	Dir		=r25

.equ	SerialIn	=	4
.equ	StrobePort	=	2
.equ	DataPort	=	1
.equ	ClockPort	=	0

.equ	DelayTime 	=	$0280
.equ	FadeDelayTime 	=	$011a
.equ	ButtonRepeat	=	$0299
.equ	StrobeAnd	=	$1f		;and for Strobe, 0f = 16 lookups. 
.equ	StrobeSpeed	=	$0170

.equ	BrightnessWrite	=	$1f

.equ	DisplaySize	=	8

Pattern:	.byte	1

;.include "2343def.inc"
.include "tn13def.inc"

.CSEG 	
	rjmp	RESET		;reset handle
	
RESET:
	ldi	temp,low(RAMEND)
	out	SPL,temp	;init Stack Pointer		
	ldi	temp,high(RAMEND)
;	out	SPH,temp
	
	ldi	Temp,$02
	sts	Pattern,Temp

	ldi	DlyA,$f0
DelayLoopA:
	ldi	DlyB,$f0
DelayLoopB:
	dec	DlyB
	brne	DelayLoopB
	dec	DlyA
	brne	DelayLoopA	
		

	ldi	Setted, $ff

	sbi	PortB,SerialIn

	ldi	Temp,$02
	sts	Position,Temp
	out	$17,Setted
	ldi	Dir,$01

	ldi	DlyA,low(DelayTime)
	ldi	DlyB,high(DelayTime)
	ldi	FadeDlyA,low(FadeDelayTime)
	ldi	FadeDlyB,high(FadeDelayTime)
	
	rcall	ClearDisplay

Loop:
	rcall	MoveDisp
	rcall	DrawDisp
	rcall	FadeDisplay
	rcall	OutDisp
	inc	TimeSlot
	andi	TimeSlot,$1f
	rjmp	Loop

ClearDisplay:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	ldi	LpCnt,$0f
	ldi	Temp,$00
ClrDispLp:
	st	Y+,Temp
	dec	LpCnt
	brne	ClrDispLp
	ret

MoveDisp:
	dec	DlyA
	brne	EndShift
	ldi	DlyA,$ff
	dec	DlyB
	brne	EndShift

	lds	Temp,Pattern
	tst	Temp
	breq	MovePattern0
	cpi	Temp,$01
	breq	MovePattern1
	rjmp	MovePattern2

MovePattern0:
	lds	Temp,Position
	cpi	Dir,$01
	breq	ShiftRight0
ShiftLeft0:
	inc	Temp
	cpi	Temp,$07
	brne	ShiftLOkay0
	ldi	Dir,$01
ShiftLOkay0:
	rjmp	ShiftComplete
ShiftRight0:
	dec	Temp
	cpi	Temp,$00
	brne	ShiftROkay0
	ldi	Dir,$00
ShiftROkay0:
	rjmp	ShiftComplete	

MovePattern1:
	lds	Temp,Position
	cpi	Dir,$01
	breq	ShiftRight1
ShiftLeft1:
	inc	Temp
	cpi	Temp,$03
	brne	ShiftLOkay1
	ldi	Dir,$01
ShiftLOkay1:
	rjmp	ShiftComplete
ShiftRight1:
	dec	Temp
	cpi	Temp,$00
	brne	ShiftROkay1
	ldi	Dir,$00
ShiftROkay1:
	rjmp	ShiftComplete	

MovePattern2:
	lds	Temp,Position
	cpi	Dir,$01
	breq	ShiftRight1
ShiftLeft2:
	inc	Temp
	cpi	Temp,$0a
	brne	ShiftLOkay2
	ldi	Dir,$01
ShiftLOkay2:
	rjmp	ShiftComplete
ShiftRight2:
	dec	Temp
	cpi	Temp,$00
	brne	ShiftROkay2
	ldi	Dir,$00
ShiftROkay2:

ShiftComplete:
;;	ldi	DlyA,$08
;;	eor	Temp,DlyA

	sts	Position,Temp

	ldi	DlyA,low(DelayTime)
	ldi	DlyB,high(DelayTime)
EndShift:
	ret

DrawDisp:
	lds	Temp,Pattern
	tst	Temp
	breq	Pattern0
	cpi	Temp,$01
	breq	Pattern1
	cpi	Temp,$02
	breq	Pattern2
	ret
	
Pattern0:
	rcall	DrawDot
	ret

Pattern1:
	
	rcall	DrawDot
	rcall	DrawMirror
	ret

Pattern2:
	rcall	DrawKR2000
	rcall	DrawMirror
	ret

DrawDot:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	lds	Temp,Position
	add	YL,Temp
	ldi	Temp,BrightnessWrite
	st	Y,Temp	
	ret

DrawMirror:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	ldi	ZH,high(Display+8)
	ldi	ZL,low(Display+8)
	ld	Temp,y+
	st	-z,Temp
	ld	Temp,y+
	st	-z,Temp
	ld	Temp,y+
	st	-z,Temp
	ld	Temp,y+
	st	-z,Temp
	ret

DrawKR2000:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	ldi	ZH,high(KR2008Pat*2)
	ldi	ZL,low(KR2008Pat*2)
	lds	Temp,Position
	lsl	Temp
	lsl	Temp
	add	zl,Temp
	rcall	LoadKR2008Byte
	rcall	LoadKR2008Byte
	rcall	LoadKR2008Byte
	rcall	LoadKR2008Byte
	ret

LoadKR2008Byte:
	;if not zero then we store it.
	lpm	Temp,z+
	ld	Temp2,y
	tst	temp
	brne	StoreKR2008Byte
	mov	Temp,Temp2
StoreKR2008Byte:
	st	y+,Temp
	ret

OutDisp:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	ldi	LpCnt,$08
;first 8 bits go in a different routine as we will be reading back switches in this one.
OutDispLpFirst8:
	cbi	PortB,ClockPort

	ld	Temp,Y+
	cbi	PortB,DataPort
	cp	TimeSlot,Temp
	brlo	NoDataSetFirst8
	sbi	PortB,DataPort
NoDataSetFirst8:	
	sbi	PortB,ClockPort	
	dec	LpCnt
	brne	OutDispLpFirst8

StrobeIt:
	cbi	PortB,StrobePort
	nop
	sbi	PortB,StrobePort

	ret

FadeDisplay:
	dec	FadeDlyA
	brne	EndFade
	ldi	FadeDlyA,$ff
	dec	FadeDlyB
	cpi	FadeDlyB,$00
	brne	EndFade
	ldi	FadeDlyA,low(FadeDelayTime)
	ldi	FadeDlyB,high(FadeDelayTime)

	ldi	YH,high(Display)
	ldi	YL,low(Display)
	ldi	LpCnt,$10
FadeDispLp:
	ld	Temp,Y
	dec	Temp
	brpl	ByteOkay
	clr	Temp
ByteOkay:
	st	Y+,Temp
	dec	LpCnt
	brne	FadeDispLp
EndFade:
	ret
	

KR2008Pat:	 
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00
	.db	$1f,$00,$00,$00
	.db	$1f,$1f,$00,$00
	.db	$1f,$1f,$1f,$00
	.db	$1f,$1f,$1f,$1f
	.db	$00,$1f,$1f,$1f
	.db	$00,$00,$1f,$1f
	.db	$00,$00,$00,$1f
	.db	$00,$00,$00,$00
	.db	$00,$00,$00,$00
