.DSEG 
Display:	.BYTE 	32
Position:	.BYTE	1
StrobePos:	.BYTE	1

.def	RamTemp		=r0

.def	Temp		=r16
.def	Temp2		=r17
.def	Setted		=r18
.def	DlyA		=r19
.def	DlyB		=r20
.def	FadeDlyA	=r21
.def	FadeDlyB	=r22
.def	LpCnt		=r23
.def	TimeSlot	=r24
.def	Inputs		=r25


.equ	SerialIn	=	4
.equ	StrobePort	=	2
.equ	DataPort	=	1
.equ	ClockPort	=	0



.equ	DelayTime 		=	$0210
.equ	FadeDelayTime 	=	$0110
.equ	ButtonRepeat	=	$0299
.equ	StrobeAnd		=	$1f		;and for Strobe, 0f = 16 lookups. 
.equ	StrobeSpeed		=	$0170

.equ	BrightnessWrite	=	$1f

.equ	DisplaySize		=	8

.include "2343def.inc"
;.include "tn13def.inc"

.CSEG 	
	rjmp	RESET		;reset handle
	
RESET:
	ldi	temp,low(RAMEND)
	out	SPL,temp	;init Stack Pointer		
	ldi	temp,high(RAMEND)
;	out	SPH,temp

	ldi		DlyA,$f0
DelayLoopA:
	ldi		DlyB,$f0
DelayLoopB:
	dec		DlyB
	brne		DelayLoopB
	dec		DlyA
	brne		DelayLoopA	
		

	ldi	Setted, $ff

	sbi	PortB,SerialIn

	ldi	Temp,$02
	sts	Position,Temp
	out	$17,Setted

	ldi	DlyA,low(DelayTime)
	ldi	DlyB,high(DelayTime)
	ldi	FadeDlyA,low(FadeDelayTime)
	ldi	FadeDlyB,high(FadeDelayTime)
	
	rcall	ClearDisplay


Loop:
	rcall		MoveDisp
	rcall		DrawDisp
	rcall		FadeDisplay
	rcall		OutDisp
	inc		TimeSlot
	andi		TimeSlot,$1f
	rjmp		Loop

ClearDisplay:
	ldi		YH,high(Display)
	ldi		YL,low(Display)
	ldi		LpCnt,$0f
	ldi		Temp,$00
ClrDispLp:
	st		Y+,Temp
	dec		LpCnt
	brne	ClrDispLp
	ret

MoveDisp:
	dec		DlyA
	brne		EndShift
	ldi		DlyA,$ff
	dec		DlyB
	brne		EndShift


	lds		Temp,Position
	inc		Temp
	andi		Temp,$0f	

ShiftComplete:

	sts		Position,Temp

	ldi		DlyA,low(DelayTime)
	ldi		DlyB,high(DelayTime)
EndShift:
	ret

DrawDisp:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	lds	Temp,Position
	add	YL,Temp
	ldi	Temp,BrightnessWrite
	st	Y,Temp	
	sbic	PinB,SerialIn
	ret
DrawDispMirror:
	ldi	YH,high(Display)
	ldi	YL,low(Display)
	lds	Temp,Position
	ldi	Temp2,DisplaySize-1
	sub	Temp2,Temp
	add	YL,Temp2
	ldi	Temp,BrightnessWrite
	st	Y,Temp	
	ret

OutDisp:
	ldi		YH,high(Display)
	ldi		YL,low(Display)
	ldi		LpCnt,$08
	ldi		Inputs,$00	
;first 8 bits go in a different routine as we will be reading back switches in this one.
OutDispLpFirst8:
	cbi		PortB,ClockPort

	ld		Temp,Y+
	cbi		PortB,DataPort
	cp		TimeSlot,Temp
	brlo	NoDataSetFirst8
	sbi		PortB,DataPort
NoDataSetFirst8:	
	sbi		PortB,ClockPort	
	dec		LpCnt
	brne	OutDispLpFirst8

StrobeIt:
	cbi		PortB,StrobePort
	nop
	sbi		PortB,StrobePort

	ret

FadeDisplay:
	dec		FadeDlyA
	brne	EndFade
	ldi		FadeDlyA,$ff
	dec		FadeDlyB
	cpi		FadeDlyB,$00
	brne	EndFade
	ldi		FadeDlyA,low(FadeDelayTime)
	ldi		FadeDlyB,high(FadeDelayTime)

	ldi		YH,high(Display)
	ldi		YL,low(Display)
	ldi		LpCnt,$10
FadeDispLp:
	ld		Temp,Y
	dec		Temp
	brpl	ByteOkay
	clr		Temp
ByteOkay:
	st		Y+,Temp
	dec		LpCnt
	brne	FadeDispLp
EndFade:
	ret
	
